definition module controldraw


//	Clean Object I/O library, version 1.0.1

//	Drawing operations on customised controls

import	wstate


/*	draw(Compound/Custom(Button))Look render their control using the current look.
	It is assumed that they are applied to a WItemHandle` argument that refers to a (Compound/CustomButton/Custom)Control respectively.
	drawCompoundLook furthermore assumes that the compound control's ClipState is valid.
*/
drawCompoundLook	:: !Bool !OSWindowPtr !WItemHandle` !*OSToolbox -> (!WItemHandle`,!*OSToolbox)
drawCustomButtonLook:: !Bool !OSWindowPtr !WItemHandle` !*OSToolbox -> (!WItemHandle`,!*OSToolbox)
drawCustomLook		:: !Bool !OSWindowPtr !WItemHandle` !*OSToolbox -> (!WItemHandle`,!*OSToolbox)

/*	drawIn(Compound/Custom(Button)) apply a list of drawing functions to the given control.
	It is assumed that they are applied to a WItemHandle` argument that refers to a (Compound/CustomButton/Custom)Control respectively.
	drawInCompound furthermore assumes that the compound control is non-transparent and has a valid ClipState.
*/
drawInCompound		:: !OSWindowPtr ![DrawFunction] !WItemHandle` !*OSToolbox -> (!WItemHandle`,!*OSToolbox)
drawInCustomButton	:: !OSWindowPtr ![DrawFunction] !WItemHandle` !*OSToolbox -> (!WItemHandle`,!*OSToolbox)
drawInCustom		:: !OSWindowPtr ![DrawFunction] !WItemHandle` !*OSToolbox -> (!WItemHandle`,!*OSToolbox)
